#include "bsp.h"
#include "uart_bsp.h"
#include "exti_bsp.h"
#include "bsp_debug.h"
#include "spi_bsp.h"
#include "dma_bsp.h"

#include "stdlib.h"

void clock_config(void);

volatile uint8_t finished=0;


uint32_t dataSource[5]={0x00,0x22,0xFF,0x55,0x33};
uint32_t dataDest[5];


DMA_ConfigTypedef DMA_Config;



int main()
{


	#if FPU_EN
		SCB->CPACR |= ((3UL << 10*2)|(3UL << 11*2));
	#endif

	clock_config();
	BSP_Ticks_Init(100000000);

	__BSP_DMA2__CLOCK_ENABLE();

	DMA_Config.DMA_Channel=Channel0;
	DMA_Config.CircularMode=SingleTransfer;
	DMA_Config.MemorySize=word;
	DMA_Config.PerpheralSize=word;
	DMA_Config.MemoryIncMode=incMode;
	DMA_Config.PeripheralIncMode=incMode;
	DMA_Config.Direction=memory2Memory;
	DMA_Config.InterruptEnable=InterruptEnbaled;
	DMA_Config.TransferCompleteInterrupt=TransferComplet;
	DMA_Config.DMAStream=dma2stream0;


	BSP_DMA_Init(DMA2_Stream0, &DMA_Config);



	while(1)
	{
		BSP_DMA_Transfer_Single_Buffer(DMA2_Stream0, &dataSource, &dataDest, 5);

		while(finished ==0){;}
		finished=0;
		for (int i=0; i<5;i++)
		{
			dataSource[i]=random()%256;
		}

	}
}

void clock_config(void)
{
	Clock_Config_Typedef clockConfig;

	clockConfig.PLL_M= 4;
	clockConfig.PLL_N= 200;
	clockConfig.PLL_P= 4;

	clockConfig.AHB1Prescaler=AHB1_Prescaler1;
	clockConfig.APB1Prescaler=APB1_Prescaler2;
	clockConfig.APB2Prescaler=APB2_Prescaler1;

	clockConfig.clockSourc=External_Oscillator;
	clockConfig.flash_latency= Three_wait_state;

	Clock_Configuration(&clockConfig);
}

void DMA2_Stream0_handler(void)
{
	if((DMA2->LISR & DMA_LISR_TCIF0)==DMA_LISR_TCIF0)
	{
		finished=1;
	}

}
